const path = require('path');
const dest = "models.d.ts";
let destSource =  (process.env.dest || '')+dest;
destSource = path.resolve(__dirname,destSource);
let source = process.env.source ||  "./model";
source = path.resolve(__dirname, source);
const { type } = require('o-system/schema/model');
const fs = require('fs/promises');
fs.readFile(path.resolve(__dirname, 'settings.json'), 'UTF-8', callback);

(async function () {
    let files = await fs.readdir(source, { withFileTypes: true });
    await fs.unlink(destSource).catch(() => { });
    let content = "";
    for (let filePath of files) {
        if (!filePath.isFile()) {
            continue;
        }
        let path = `${source}/${filePath.name}`
        let m = require(path);
        let fileName = filePath.name.split('.')[0];
        for(let key of Object.keys(m)){
            let model = m[key];
            let typeScript = findModel(model,1);
            if(typeScript == null){
                continue;
            }
            let name =  toCamelCase(fileName)+toCamelCase(key);
            let exported = `export declare class ${name} ${typeScript}`;
            content +=exported +"\r\n\r\n\r\n";
        }
    
   
    }
    let r = await t.processString(destSource,content,{
        tsfmt:''
    });
    await fs.writeFile(destSource,r.dest);
   
})();

function toCamelCase(name){
    return name[0].toUpperCase()+name.substr(1,name.length);
}


function findModel(model, index = 1) {
    if(model[type] != null){
        return null;
    }
    if (index > 10) {
        return "";
    }
    let keys = Object.keys(model);
    let range = function (a) {
        let results = [];
        for (let x = 0; x < a; x++) {
            results.push(x);
        }
        return results;
    }
    let pad = function (i) {
        if (i === 0) {
            return range(index).reduce((r) => r + "\t", "");
        }
        return "\r\n" + range(index).reduce((r) => r + "\t", "");
    }
    let content = keys.reduce((r, key, i) => r + `${pad(i)}${key}: ${getType(model[key], index)};`, "");
    return `{\r\n${content}\r\n${range(index-1).reduce(r=>r + "\t","")}}`;
}

function getType(value, i) {
    if (isType(value, String)) {
        return "String";
    } else if (isType(value, Number)) {
        return "Number";
    } else if (isType(value, Boolean)) {
        return "Boolean";
    }
    else if (isType(value, Date)) {
        return "Date";
    } else if (Array.isArray(value)) {
        let element = value[0];
        if (element == null) {
            return `Array<any>`;
        }
        return `Array<${getType(element)}>`
    } else if (isType(value, Array)) {
        return "Array<any>";
    }
    else if(typeof value === "object" && value[type] != null){
        if(value[type] === Array){
            return `Array<${getType(value.element,i +1)}>`
        }
        return getType(value[type],i+1);
    }
    else if (typeof value === "object" || isType(value,Object)) {
        if(value[type] != null){
          return findModel(value[type], i + 1);
        }
        return findModel(value, i + 1);
    }
    if(value[type] != null){
        return getType(value[type],i);
    }
    return "String";
}




function isType(value, t) {
    if (value === t) {
        return true;
    }
    return t[type] === value;
}
